/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: mife_int.h,v 1.3 2007/05/24 01:15:30 babolo Exp $
 */

#define MINEOLN 0x0F           /*****************************************
                                *    eoln              */
#define MAXPACKT (1 << 16)     /*****************************************
                                *       *
                                * ,       *
                                *  read(2)  (          *
                                *  sa(4))                             *
                                * !!!   2 !!!         */
#define MINDELTA (MAXPACKT * 4)/*****************************************
                                *     ,      *
                                * 2   .    *
                                *      SCSI   *
                                *  mtu  loopback.    .   *
                                *        *
                                *   realloc()            */
#define NRETRY00 2             /*****************************************
                                *  read(2)    *
                                *   ,  ,    *
                                *      *
                                * read() == 0 NRETRY00  .      */
#define DEFMEM 0x80000000      /*****************************************
                                *  DEFMEM >> 8 ,             *
                                *    .           *
                                *****************************************/

#define CHARBUF(A)     ((const char * const)(A))
#define eolstop(mife)  {(mife)->eolst = -1;}

#define eolstart(mife, delta)    \
{   if  ((mife)->eolst <= 0) {   \
    (mife)->eolp = (delta);      \
    (mife)->eolst = 0;           \
}   }

#define eoldelta(mife, delta)    \
{   if  ((mife)->eolst >= 0) {   \
        (mife)->eolp += (delta); \
        if  ((mife)->eolp < 0) { \
            (mife)->eolp = 0;    \
            (mife)->eolst = 0;   \
}   }   }
